package acme.mdb;

import java.util.logging.Logger;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.Message;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;

/**
 * Bean implementation class for Enterprise Bean: MessagePost
 */
public class MessagePostBean implements javax.ejb.SessionBean {
	private javax.ejb.SessionContext mySessionCtx;
	
    private static final Logger log = Logger.getLogger("acme.mdb.MessagePostBean.class");


	ConnectionFactory connectionFactory;

	Destination topic;

	Connection connection;

	Session session;

	MessageProducer publisher;

	/**
	 * getSessionContext
	 */
	public javax.ejb.SessionContext getSessionContext() {
		return mySessionCtx;
	}

	/**
	 * setSessionContext
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx) {
		mySessionCtx = ctx;
	}

	/**
	 * ejbCreate
	 */
	public void ejbCreate() throws javax.ejb.CreateException {
		setUpJMS();
	}

	public void postMessage(int i) {
         try
         {
            Message m = session.createObjectMessage(new Integer(i));

            publisher.send(m);

            log.info("message " + i + " sent");
         }
         catch(Exception e)
         {
            log.severe(e.getMessage());
         }

	}

	private boolean setUpJMS() {
		try {
			Context ic = (Context)(new InitialContext()).lookup("java:comp/env");

			connectionFactory = (ConnectionFactory) ic.lookup("ref_TopicCF");

			topic = (Destination) ic.lookup("ref_Topic");

			connection = connectionFactory.createConnection();

			session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);

			publisher = session.createProducer(topic);

			return true;
		} catch (Throwable t) {
			log.severe("Exception in setUpJMS()" + t);

			try {
				connection.stop();
				session.close();
				connection.close();

			} catch (javax.jms.JMSException jmse) {
				log.severe(""+jmse);
			}

			return false;
		}
	}

	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}

	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}

	/**
	 * ejbRemove
	 */
	public void ejbRemove() {
	}
}
